<template>
    <div class="login-form__container">
        <div v-if="isLoggedIn">
            <a
                class="login-link"
                href=""
                @click.prevent="onLogoutClick"
            >Logout<i class="fas fa-sign-out-alt"></i></a>
        </div>
        <div v-else-if="!showLoginForm">
            <a
                class="login-link"
                href=""
                @click.prevent="onLoginClick"
            >Login<i class="fas fa-sign-in-alt"></i></a>
        </div>
        <form
            class="login-form__form"
            action=""
            v-if="!isLoggedIn && showLoginForm"
            @submit.prevent="onLoginSubmit"
        >
            <material-field
                placeholder="Username"
                class="mdc-text-field--with-leading-icon login-form__input"
                v-model="username"
            >
                <template v-slot:leading-icon>
                    <material-textfield-icon type="leading" icon="fa-user"></material-textfield-icon>
                </template>
            </material-field>
            <material-field
                placeholder="Password"
                type="password"
                class="mdc-text-field--with-leading-icon login-form__input"
                v-model="password"
            >
                <template v-slot:leading-icon>
                    <material-textfield-icon type="leading" icon="fa-lock"></material-textfield-icon>
                </template>
            </material-field>
            <material-button type="submit" class="login-form__button">Login</material-button>
        </form>
    </div>
</template>
<script>
import jwtDecode from 'jwt-decode';

export default {
    data() {
        return {
            showLoginForm: false,
            isLoggedIn: false,
            username: '',
            password: '',
        };
    },

    created() {
        this.isLoggedIn = this.getIsLoggedIn()

        if (this.isLoggedIn) {
            this.$emit('login-successful', this.getUser(localStorage.getItem('jwt')));
        }
    },

    methods: {
        onLoginClick() {
            this.showLoginForm = true;
        },

        onLoginSubmit() {
            axios.post('login', {
                    username: this.username,
                    password: this.password,
                }, {
                    baseURL: `${process.env.MIX_APP_URL}/auth`,
                    headers: {
                        Accept: 'application/json',
                    },
                })
                .then(response => {
                    const token = {
                        jwt: response.data.access_token,
                        expiresIn: response.data.expires_in,
                    };

                    this.onLoginSuccessful(token);

                    this.$emit('login-successful', this.getUser(token.jwt));
                })
                .catch(error => {
                    this.$toasted.global.apiError(error);

                    this.isLoggedIn = false;
                });
        },

        onLoginSuccessful(token) {
            const date = new Date();
            date.setSeconds(date.getSeconds() + token.expiresIn);
            localStorage.setItem('jwt-expires-at', parseInt((date.getTime() / 1000).toFixed(0)).toString());
            localStorage.setItem('jwt', token.jwt);

            this.isLoggedIn = true;
            this.showLoginForm = false;
            this.username = '';
            this.password = '';

            this.$toasted.show('Login successful', {
                icon: 'user-circle',
            })
        },

        onLogoutClick() {
            localStorage.removeItem('jwt');
            localStorage.removeItem('jwt-expires-at');

            this.isLoggedIn = false;

            this.$toasted.show('Logged out', {
                icon: 'user-circle',
            })

            this.$emit('logout-successful');
        },

        getIsLoggedIn() {
            if (localStorage.getItem('jwt') === null) {
                return false;
            }

            return new Date(localStorage.getItem('jwt-expires-at') * 1000) > new Date();
        },

        getUser(jwt) {
            if (jwt === null) {
                return null;
            }

            const decodedJwt = jwtDecode(jwt);

            return {
                id: decodedJwt.sub,
                isAdmin: decodedJwt.admin,
            };
        },
    },
};
</script>
<style>
.login-link > .fas {
    margin: .2rem;
}

@media screen and (max-width: 360px) {
    .login-form__input {
        margin-top: 5px;
    }

    .login-form__form {
        display: flex;
        flex-direction: column;
    }

    .login-form__button {
        margin: 5px auto 0;
    }
}
</style>
